# xighlight

## xighlight -- Program for highlighting program output, source code and various text files in terminal.

Compile: `$ sh compile.sh`

Install: `$ sudo sh install.sh`

License: GNU/GPLv3

This library depends on (these libraries are included in static version of the program):
- xtandard: https://gitlab.com/xolatile/xtandard
- xyntax:   https://gitlab.com/xolatile/xyntax
- xanguage: https://gitlab.com/xolatile/xanguage

About this program:
- It is extremely slow, it's written to be generic and extensible, not language specific or optimized.
- You can easily add new syntax support with it, for your own language or some that I didn't include.
- There are 3 ways to use this program, you can see them below, or use -h / --help to see it.
- Everything related to my libraries is clean of all warning options on GCC and Valgrind (hopefully).

Use:
```bash
$ xighlight my_program.ext                   -- "This way, language is selected by the extension."
$ cat my_program.ext | xighlight [extension] -- "You need to specify the language, check -h / --help."
$ xighlight [extension] < my_program.ext     -- "Again, since it's reading from standard stream..."
```

![screenshot](screenshot.png)
