static procedure language_highlight_cpp (language_structure * language, syntax_structure * syntax) {
	character * separators = ".,:;<=>+-*/%!&~^?|()[]{}'\" \t\r\n";

	character * keywords [] = {
		"alignas",      "alignof",      "and",          "asm",          "auto",         "break",        "case",
		"catch",        "class",        "compl",        "concept",      "const",        "consteval",    "constexpr",
		"constinit",    "continue",     "decltype",     "default",      "delete",       "do",           "else",
		"enum",         "explicit",     "export",       "extern",       "false",        "for",          "friend",
		"goto",         "if",           "inline",       "mutable",      "namespace",    "new",
		"noexcept",     "not",          "nullptr",      "operator",     "or",           "private",      "protected",    "public",
		"reflexpr",     "register",     "requires",     "return",       "sizeof",       "static",
		"struct",       "switch",       "synchronized", "template",     "this",         "throw",        "true",         "try",
		"typedef",      "typeid",       "typename",     "union",        "using",        "virtual",
		"volatile",     "while",        "xor",          "final",        "override",     "import",       "module"
	};

	character * types [] = {
		"v0",         "boolean",         "off_t",        "va_list",      "float",        "double",       "float_t",      "double_t",
		"char",         "short",        "int",          "long",         "uchar",        "ushort",       "uint",         "ulong",
		"int8_t",       "int16_t",      "int32_t",      "int64_t",      "uint8_t",      "uint16_t",     "uint32_t",     "uint64_t",
		"signed",       "unsigned",     "size_t",       "ssize_t"
	};

	character * commons [] = {
		"std",          "FILE",         "DIR",          "EOF",          "va_arg",       "va_start",     "va_end",       "va_copy"
	};

	syntax_define (syntax, false, false, "/*", "*/", '\0', language->comment_colour,   language->comment_effect);
	syntax_define (syntax, false, false, "//", "\n", '\0', language->comment_colour,   language->comment_effect);
	syntax_define (syntax, false, false, "#",  "\n", '\\', language->processor_colour, language->processor_effect);
	syntax_define (syntax, false, false, "'",  "'",  '\\', language->character_colour, language->character_effect);
	syntax_define (syntax, false, false, "\"", "\"", '\\', language->string_colour,    language->string_effect);

	for (natural_64 word = 0; word < array_length (keywords); ++word) {
		syntax_define (syntax, false, true, keywords [word], separators, '\0', language->keyword_colour, language->keyword_effect);
	}

	for (natural_64 word = 0; word < array_length (types); ++word) {
		syntax_define (syntax, false, true, types [word], separators, '\0', language->type_colour, language->type_effect);
	}

	for (natural_64 word = 0; word < array_length (commons); ++word) {
		syntax_define (syntax, false, true, commons [word], separators, '\0', language->extension_colour, language->extension_effect);
	}

	syntax_define (syntax, true, false, "()[]{}",             "", '\0', language->bracket_colour,  language->bracket_effect);
	syntax_define (syntax, true, false, ".,:;<=>+*-/%!&~^?|", "", '\0', language->operator_colour, language->operator_effect);

	syntax_define (syntax, true, true, language_digits,    separators, '\0', language->number_colour,     language->number_effect);
	syntax_define (syntax, true, true, language_lowercase, separators, '\0', language->lowercase_colour,  language->lowercase_effect);
	syntax_define (syntax, true, true, language_uppercase, separators, '\0', language->uppercase_colour,  language->uppercase_effect);
	syntax_define (syntax, true, true, "_",                separators, '\0', language->underscore_colour, language->underscore_effect);
}
