static procedure language_highlight_c (language_structure * language, syntax_structure * syntax) {
	character * separators = ".,:;<=>+-*/%!&~^?|()[]{}'\" \t\r\n";

	character * keywords [] = {
		"register",     "volatile",     "auto",         "const",        "static",       "extern",       "if",           "else",
		"do",           "while",        "for",          "continue",     "switch",       "case",         "default",      "break",
		"enum",         "union",        "struct",       "typedef",      "goto",         "return",       "sizeof",       "inline",
		"restrict",     "true",         "false"
	};

	character * types [] = {
		"void",         "bool",         "off_t",        "va_list",      "float",        "double",       "float_t",      "double_t",
		"char",         "short",        "int",          "long",         "uchar",        "ushort",       "uint",         "ulong",
		"int8_t",       "int16_t",      "int32_t",      "int64_t",      "uint8_t",      "uint16_t",     "uint32_t",     "uint64_t",
		"integer_8",           "integer_16",           "integer",           "integer_64",           "natural_8",           "natural_16",           "natural",           "natural_64",
		"real",           "real_64",           "v0",           "character",           "boolean",           "pstring",      "signed",       "unsigned",
		"size_t",       "ssize_t"
	};

	character * commons [] = {
		"null",         "NULL",         "FILE",         "DIR",          "va_arg",       "va_start",     "va_end",       "va_copy",
		"alignas",      "alignof",      "offsetof",     "typeof",       "EOF",          "ABS",          "MIN",          "MAX",
		"ARRAYSIZE",    "SWAP",         "UNUSED",       "UNREACHABLE",  "STRINGIFY",    "CONCAT",       "assert",       "nullptr",
		"thread_local", "static_assert"
	};

	syntax_define (syntax, false, false, "/*",  "*/", '\0', language->comment_colour,   language->comment_effect);
	syntax_define (syntax, false, false, "//",  "\n", '\0', language->comment_colour,   language->comment_effect);
	syntax_define (syntax, false, false, "#",   "\n", '\\', language->processor_colour, language->processor_effect);
	syntax_define (syntax, false, false, "'",   "'",  '\\', language->character_colour, language->character_effect);
	syntax_define (syntax, false, false, "\"",  "\"", '\\', language->string_colour,    language->string_effect);

	for (natural_64 word = 0; word < array_length (keywords); ++word) {
		syntax_define (syntax, false, true, keywords [word], separators, '\0', language->keyword_colour, language->keyword_effect);
	}

	for (natural_64 word = 0; word < array_length (types); ++word) {
		syntax_define (syntax, false, true, types [word], separators, '\0', language->type_colour, language->type_effect);
	}

	for (natural_64 word = 0; word < array_length (commons); ++word) {
		syntax_define (syntax, false, true, commons [word], separators, '\0', language->extension_colour, language->extension_effect);
	}

	syntax_define (syntax, true, false, "()[]{}",             "", '\0', language->bracket_colour,  language->bracket_effect);
	syntax_define (syntax, true, false, ".,:;<=>+*-/%!&~^?|", "", '\0', language->operator_colour, language->operator_effect);

	syntax_define (syntax, true, true, language_digits,    separators, '\0', language->number_colour,     language->number_effect);
	syntax_define (syntax, true, true, language_lowercase, separators, '\0', language->lowercase_colour,  language->lowercase_effect);
	syntax_define (syntax, true, true, language_uppercase, separators, '\0', language->uppercase_colour,  language->uppercase_effect);
	syntax_define (syntax, true, true, "_",                separators, '\0', language->underscore_colour, language->underscore_effect);
}
